﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace mobiledata
{
    abstract class MobileDataFactory
    {
        private static String connectionString;

        protected static String ConnectionString
        {
            get { return MobileDataFactory.connectionString; }
            set { MobileDataFactory.connectionString = value; }
        }

        protected static DatabaseKind databaseKind;


        /// <summary>
        /// Initializes database factory class.
        /// </summary>
        /// <param name="connString"></param>
        /// <param name="dbKind"></param>
        public static void init(String connString, DatabaseKind dbKind)
        {
            connectionString = connString;
            databaseKind = dbKind;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        static MobileDataFactory createFactory()
        {
            if (databaseKind == DatabaseKind.MySql)
            {
                return new MysqlMobileDataFactory();
            }
            else
            {
                throw new Exception("Unsupported database type");
            }
            
        }

        /// <summary>
        /// 
        /// </summary>
        public static MobileDataFactory instance = createFactory();

        /// <summary>
        /// 
        /// </summary>
        protected MobileDataFactory() { }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public abstract IDbConnection createConnection();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public abstract MobileDataManagerImpl createDBAdapter();

    }
}
